/**
*
*Copyright 2010 Microsoft Corp
*
*Licensed under the Apache License, Version 2.0 (the "License");
*you may not use this file except in compliance with the License.
*You may obtain a copy of the License at
*
*http://www.apache.org/licenses/LICENSE-2.0
*
*Unless required by applicable law or agreed to in writing, software
*distributed under the License is distributed on an "AS IS" BASIS,
*WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
*See the License for the specific language governing permissions and
*limitations under the License.
*/
/**
* This code was generated by the tool 'odatagen'.
* Runtime Version:1.0
*
* Changes to this file may cause incorrect behavior and will be lost if
* the code is regenerated.
*/
/**
* Defines default Data Service URL for this proxy class
*/
#define DEFAULT_SERVICE_URL @""


#define DataServiceVersion @"2.0"

#import "ODataObject.h"
#import "ObjectContext.h"
#import "DataServiceQuery.h"
#import "ODataGUID.h"
#import "ODataBool.h"
#import  "mProperties.h"


/**
 * @interface:Address
 */
@interface ODataDemo_Address :ODataObject
{
	/**
	* @Type:ComplexTypeProperty
	* @EdmType:Edm.String
	* @MaxLength:
	* @FixedLength:
	*/
	NSString *m_Street;
	
	/**
	* @Type:ComplexTypeProperty
	* @EdmType:Edm.String
	* @MaxLength:
	* @FixedLength:
	*/
	NSString *m_City;
	
	/**
	* @Type:ComplexTypeProperty
	* @EdmType:Edm.String
	* @MaxLength:
	* @FixedLength:
	*/
	NSString *m_State;
	
	/**
	* @Type:ComplexTypeProperty
	* @EdmType:Edm.String
	* @MaxLength:
	* @FixedLength:
	*/
	NSString *m_ZipCode;
	
	/**
	* @Type:ComplexTypeProperty
	* @EdmType:Edm.String
	* @MaxLength:
	* @FixedLength:
	*/
	NSString *m_Country;
	
}

@property ( nonatomic , retain , getter=getStreet , setter=setStreet ) NSString *m_Street;
@property ( nonatomic , retain , getter=getCity , setter=setCity ) NSString *m_City;
@property ( nonatomic , retain , getter=getState , setter=setState ) NSString *m_State;
@property ( nonatomic , retain , getter=getZipCode , setter=setZipCode ) NSString *m_ZipCode;
@property ( nonatomic , retain , getter=getCountry , setter=setCountry ) NSString *m_Country;

@end

/**
 * @interface:Product
 * @Type:EntityType
 
 * @key:ID* 
 */
@interface ODataDemo_Product : ODataObject
{
	
	/**
	* @Type:EntityProperty
	* NotNullable
	* @EdmType:Edm.Int32
	*/
	NSNumber *m_ID;
	
	/**
	* @Type:EntityProperty
	* @EdmType:Edm.String
	* @MaxLength:
	* @FixedLength:
	* @FC_TargetPath:SyndicationTitle
	* @FC_ContentKind:text
	* @FC_NsPrefix:
	* @FC_NsUri:
	* @FC_KeepInContent:false
   * @FC_Criteria:NIL
	
	*/
	NSString *m_Name;
	
	/**
	* @Type:EntityProperty
	* @EdmType:Edm.String
	* @MaxLength:
	* @FixedLength:
	* @FC_TargetPath:SyndicationSummary
	* @FC_ContentKind:text
	* @FC_NsPrefix:
	* @FC_NsUri:
	* @FC_KeepInContent:false
   * @FC_Criteria:NIL
	
	*/
	NSString *m_Description;
	
	/**
	* @Type:EntityProperty
	* NotNullable
	* @EdmType:Edm.DateTime
	*/
	NSDate *m_ReleaseDate;
	
	/**
	* @Type:EntityProperty
	* @EdmType:Edm.DateTime
	*/
	NSDate *m_DiscontinuedDate;
	
	/**
	* @Type:EntityProperty
	* NotNullable
	* @EdmType:Edm.Int32
	*/
	NSNumber *m_Rating;
	
	/**
	* @Type:EntityProperty
	* NotNullable
	* @EdmType:Edm.Decimal
	*/
	NSDecimalNumber *m_Price;
	
	/**
	* @Type:NavigationProperty
	* @Relationship:Product_Category_Category_Products
	* @FromRole:Product_Category
	* @ToRole:Category_Products
	*/
	NSMutableArray *m_Category;
	
	/**
	* @Type:NavigationProperty
	* @Relationship:Product_Supplier_Supplier_Products
	* @FromRole:Product_Supplier
	* @ToRole:Supplier_Products
	*/
	NSMutableArray *m_Supplier;
	
}

@property ( nonatomic , retain , getter=getID , setter=setID )NSNumber *m_ID;
@property ( nonatomic , retain , getter=getName , setter=setName ) NSString *m_Name;
@property ( nonatomic , retain , getter=getDescription , setter=setDescription ) NSString *m_Description;
@property ( nonatomic , retain , getter=getReleaseDate , setter=setReleaseDate )NSDate *m_ReleaseDate;
@property ( nonatomic , retain , getter=getDiscontinuedDate , setter=setDiscontinuedDate )NSDate *m_DiscontinuedDate;
@property ( nonatomic , retain , getter=getRating , setter=setRating )NSNumber *m_Rating;
@property ( nonatomic , retain , getter=getPrice , setter=setPrice )NSDecimalNumber *m_Price;
@property ( nonatomic , retain , getter=getCategory , setter=setCategory )NSMutableArray *m_Category;
@property ( nonatomic , retain , getter=getSupplier , setter=setSupplier )NSMutableArray *m_Supplier;

+ (id) CreateProductWithid:(NSNumber *)aID releasedate:(NSDate *)aReleaseDate rating:(NSNumber *)aRating price:(NSDecimalNumber *)aPrice;
- (id) init;
- (id) initWithUri:(NSString*)anUri;
@end

/**
 * @interface:Category
 * @Type:EntityType
 
 * @key:ID* 
 */
@interface ODataDemo_Category : ODataObject
{
	
	/**
	* @Type:EntityProperty
	* NotNullable
	* @EdmType:Edm.Int32
	*/
	NSNumber *m_ID;
	
	/**
	* @Type:EntityProperty
	* @EdmType:Edm.String
	* @MaxLength:
	* @FixedLength:
	* @FC_TargetPath:SyndicationTitle
	* @FC_ContentKind:text
	* @FC_NsPrefix:
	* @FC_NsUri:
	* @FC_KeepInContent:true
   * @FC_Criteria:NIL
	
	*/
	NSString *m_Name;
	
	/**
	* @Type:NavigationProperty
	* @Relationship:Product_Category_Category_Products
	* @FromRole:Category_Products
	* @ToRole:Product_Category
	*/
	NSMutableArray *m_Products;
	
}

@property ( nonatomic , retain , getter=getID , setter=setID )NSNumber *m_ID;
@property ( nonatomic , retain , getter=getName , setter=setName ) NSString *m_Name;
@property ( nonatomic , retain , getter=getProducts , setter=setProducts )NSMutableArray *m_Products;

+ (id) CreateCategoryWithid:(NSNumber *)aID;
- (id) init;
- (id) initWithUri:(NSString*)anUri;
@end

/**
 * @interface:Supplier
 * @Type:EntityType
 
 * @key:ID* 
 */
@interface ODataDemo_Supplier : ODataObject
{
	
	/**
	* @Type:EntityProperty
	* NotNullable
	* @EdmType:Edm.Int32
	*/
	NSNumber *m_ID;
	
	/**
	* @Type:EntityProperty
	* @EdmType:Edm.String
	* @MaxLength:
	* @FixedLength:
	* @FC_TargetPath:SyndicationTitle
	* @FC_ContentKind:text
	* @FC_NsPrefix:
	* @FC_NsUri:
	* @FC_KeepInContent:true
   * @FC_Criteria:NIL
	
	*/
	NSString *m_Name;
	
	/**
	* @Type:EntityProperty
	* NotNullable
	* @EdmType:ODataDemo.Address
	*/
	ODataDemo_Address *m_Address;
	
	/**
	* @Type:EntityProperty
	* NotNullable
	* @EdmType:Edm.Int32
	*/
	NSNumber *m_Concurrency;
	
	/**
	* @Type:NavigationProperty
	* @Relationship:Product_Supplier_Supplier_Products
	* @FromRole:Supplier_Products
	* @ToRole:Product_Supplier
	*/
	NSMutableArray *m_Products;
	
}

@property ( nonatomic , retain , getter=getID , setter=setID )NSNumber *m_ID;
@property ( nonatomic , retain , getter=getName , setter=setName ) NSString *m_Name;
@property ( nonatomic ,  retain , getter=getAddress , setter=setAddress )ODataDemo_Address *m_Address;
@property ( nonatomic , retain , getter=getConcurrency , setter=setConcurrency )NSNumber *m_Concurrency;
@property ( nonatomic , retain , getter=getProducts , setter=setProducts )NSMutableArray *m_Products;

+ (id) CreateSupplierWithid:(NSNumber *)aID address:(ODataDemo_Address *)aAddress concurrency:(NSNumber *)aConcurrency;
- (id) init;
- (id) initWithUri:(NSString*)anUri;
@end

/**
 * Container interface DemoService, Namespace: ODataDemo
 */
@interface DemoService : ObjectContext
{
	 NSString *m_OData_etag;
	 DataServiceQuery *m_Products;
	 DataServiceQuery *m_Categories;
	 DataServiceQuery *m_Suppliers;
	
}

@property ( nonatomic , retain , getter=getEtag , setter=setEtag )NSString *m_OData_etag;
@property ( nonatomic , retain , getter=getProducts , setter=setProducts ) DataServiceQuery *m_Products;
@property ( nonatomic , retain , getter=getCategories , setter=setCategories ) DataServiceQuery *m_Categories;
@property ( nonatomic , retain , getter=getSuppliers , setter=setSuppliers ) DataServiceQuery *m_Suppliers;

- (id) init;
- (id) initWithUri:(NSString*)anUri credential:(id)acredential;
- (NSArray *) GetProductsByRatingWithrating:(NSNumber *)rating;
- (id) products;
- (id) categories;
- (id) suppliers;
- (void) addToProducts:(id)anObject;
- (void) addToCategories:(id)anObject;
- (void) addToSuppliers:(id)anObject;

@end
